package scj.algorithm.tree.leftside;

import it.unimi.dsi.fastutil.ints.IntArrayList;
import scj.algorithm.tree.Tree;
import it.unimi.dsi.fastutil.ints.IntList;

public abstract class FlatLeftTree implements Tree {

	protected int size;
	protected IntList nodeNames;
	protected IntList tupleIdPositions;
	protected IntList tupleIds;
	protected IntArrayList childrenPositions;
	protected IntList children;

	public FlatLeftTree() {
		super();
	}

	public int getSize() {
		return this.size;
	}

	public IntList getIdsByPosition(int scope_start) {
		return findSubListOfList(this.tupleIdPositions, this.tupleIds, scope_start);
	}

	public IntList getChildrenOf(int scope_start) {
		return findSubListOfList(this.childrenPositions, this.children, scope_start);
	}

	public int getNameOf(int id) {
		return this.nodeNames.getInt(id);
	}

	protected IntList findSubListOfList(IntList positionList, IntList valueList, int scope_start) {
		int end;
		if(scope_start+1 < positionList.size()) {
			end = (positionList.getInt(scope_start + 1));
		} else {
			end = (valueList.size());
		}
		return valueList.subList(
				positionList.getInt(scope_start), end);
	}

}