package scj.algorithm.tree.leftside.semi;

import it.unimi.dsi.fastutil.ints.IntArrayList;
import it.unimi.dsi.fastutil.ints.IntList;
import it.unimi.dsi.fastutil.objects.ObjectList;
import scj.algorithm.tree.Tree;

public abstract class SemiFlatLeftTree implements Tree {

	protected int size;
	protected IntList nodeNames;
	protected IntList tupleIdPositions;
	protected IntList tupleIds;
    protected ObjectList<IntArrayList> childrenVertical;

	public SemiFlatLeftTree() {
		super();
	}

	public int getSize() {
		return this.size;
	}

	public IntList getIdsByPosition(int scope_start) {
		return findSubListOfList(this.tupleIdPositions, this.tupleIds, scope_start);
	}

	public IntList getChildrenOf(int scope_start) {
        IntArrayList vertical = childrenVertical.get(scope_start);
        if(vertical == null) {
            return new IntArrayList(1);
        }
        return vertical;
	}

	public int getNameOf(int id) {
		return this.nodeNames.getInt(id);
	}

	protected IntList findSubListOfList(IntList positionList, IntList valueList, int scope_start) {
		int end;
		if(scope_start+1 < positionList.size()) {
			end = (positionList.getInt(scope_start + 1));
		} else {
			end = (valueList.size());
		}
		return valueList.subList(
				positionList.getInt(scope_start), end);
	}

}